# ZOQL

ZOQL is a Ruby gem for parsing and working with Zuora ZOQL queries.

## Installation

Install the gem and add to the application's Gemfile by executing:

```sh
bundle add gitlab-zoql
```

If `bundler` is not being used to manage dependencies, install the gem by executing:

```sh
gem install gitlab-zoql
```

## Usage

```ruby
ast = GitlabZOQL::Parser.parse('SELECT AccountId, FirstName, LastName FROM contact WHERE State = \'California\'')

# explose the AST
ast.query_expression.table_expression.where_clause.search_condition.left.name

# returns State

ast.query_expression.table_expression.where_clause.search_condition.right.value
# returns California
```

## Development

After checking out the repo, run `bin/setup` to install dependencies. Then, run `rake test` to run the tests. You can also run `bin/console` for an interactive prompt that will allow you to experiment.

To install this gem onto your local machine, run `bundle exec rake install`. To release a new version, update the version number in `version.rb`, and then run `bundle exec rake release`, which will create a git tag for the version, push git commits and the created tag, and push the `.gem` file to [rubygems.org](https://rubygems.org).

## Contributing

Bug reports and pull requests are welcome on GitLat at https://gitlab.com/gitlab-org/ruby/gems/gitlab-zoql. This project is intended to be a safe, welcoming space for collaboration, and contributors are expected to adhere to the [code of conduct](https://gitlab.com/gitlab-org/ruby/gems/gitlab-zoql/-/blob/main/CODE_OF_CONDUCT.md).

## License

The gem is available as open source under the terms of the [MIT License](https://opensource.org/licenses/MIT).

